/* Copyright (C) 2005  Jean-Franois Geyelin */

#include "all.h"
//#include "sprites.h"
#include "GrayClipISSprite8.h"
void draw_life_left(short, short, char, char *, char *);



#define Pixel(p,x,y,mode) PortSet(p,239,127);DrawPix(x,y,mode);


void Pixel4(short mode,short x,short y, short d) {//Used when drawing the mini-map
	short i;
	for (i=2;i--;) {
		PortSet(GrayGetPlane(i),239,127);

		//DrawPix(x,y,mode);
		DrawPix(x+d,y,mode);
		DrawPix(x,y+1,mode);
		DrawPix(x+1,y+1,mode);
		if (mode == A_XOR) {
			DrawPix(x,y+2,mode);
			DrawPix(x+1,y+2,mode);				
		}
	}
}


void draw_map(ENNEMI_STRUCT *e, short x, short y) {
	GrayDrawRect2B(x,y,x+33,y+37, COLOR_WHITE,RECT_FILLED,GrayGetPlane(0),GrayGetPlane(1));	
	//GrayDrawRect2B(x,y,x+33,y+36, COLOR_BLACK,RECT_FILLED,GrayGetPlane(0),GrayGetPlane(1));
	x++;
	y++;
	short i,j;
	for (i=32;i--;) {
		for (j=2;j<38;j++) {
			EXT_SETPIX(GrayGetPlane(DARK_PLANE),i+x,j-2+y);
			if (!map[j][i])
			EXT_SETPIX(GrayGetPlane(LIGHT_PLANE),i+x,j-2+y);
			else
			EXT_CLRPIX(GrayGetPlane(LIGHT_PLANE),i+x,j-2+y);
		}
	}
	
	for (i=MAX_ENNEMIES;i--;) {
		if (e[i].visible)
		Pixel4(A_REVERSE,(e[i].X.s_x>>(H_S+3))+x,(e[i].s_y>>(V_S+3))+y-2,e[i].X.s_vx<0);
	}
}


void draw_score(long a) {
	short i;
	char s[10];
	sprintf(s,"%li",a);
	short b;
	for (i=0;s[i];i++) {
		b=(s[i]-'0')<<3;
		GrayTile8x8_MASK_R(i,LCD_HEIGHT-8,&numbers_sprites[b],&numbers_sprites[b],&numbers_mask[b],&numbers_mask[b],pl,pd);
	}
}

void draw_score_anywhere(long a, short x, short y, char *p1, char* p2) {
	short i;
	char s[10];
	sprintf(s,"%li",a);
	short b;
	for (i=0;s[i];i++) {
		b=(s[i]-'0')<<3;
		GraySprite8_MASK_R(x+(i<<3),y,8,&numbers_sprites[b],&numbers_sprites[b],&numbers_mask[b],&numbers_mask[b],p1,p2);
	}	
}


void draw_ennemi(ENNEMI_STRUCT * e,short x, short y) {
	//char * p;
	if (e->reversed) {		
		short * sprite;		
		if (e->X.id == ID_TURTLE)
		y-=4;
		sprite = reversed_ennemies[e->X.id];
		if (e->frame&1)
		sprite+=3*16;
		GrayClipISprite16_MASK_R((e->X.s_x>>H_S)-x+e->c,(e->s_y>>6)-y,16,sprite,pl,pd);
	}
	else
	{
		GrayClipISprite16_MASK_R((e->X.s_x>>H_S)-x,(e->s_y>>6)-y,16,e->sprite+(((e->frame)<<6)-(e->frame<<4))+((e->X.s_vx<0)<<7)+((e->X.s_vx<0)<<4),pl,pd);
	}
}


static char local_s_vx[] = {7*2,-3*2,-7*2,3*2};//2*cos(20+k*90)*2^3  k={0,1,2,3} en degrs
static char local_s_vy[] = {3*2,7*2,-3*2,-7*2};//2*sin(20+k*90)*2^3  k={0,1,2,3}

void draw_dead_anim(DEAD_ENNEMI_ANIMATION_STRUCT * a, short x, short y) {
	short i=4;
	if (a->time < 15) {
		for (;i--;) {
			GrayClipSprite8_AND_R((a->star_s_x[i]>>3)-x,(a->star_s_y[i]>>3)-y,7,star_sprite,star_sprite,pl,pd);
			a->star_s_x[i]+=local_s_vx[i];
			a->star_s_y[i]+=local_s_vy[i];
		}
	}
	a->time++;
	a->s_x+=a->s_vx;
	a->s_vy+=3;
	a->s_y+=a->s_vy;
	if (a->s_vy>30)
	a->s_vy=30;
	
	GrayClipISprite16_MASK_R(((a->s_x)>>3)-x,((a->s_y)>>3)-y,16,reversed_ennemies[a->id],pl,pd);
	
	if ((a->s_y>>3) > 300) {
		a->on = 0;
		/*i=MAX_DEAD_ANIM;
		while (!dead_anim[i].on) {i--;};
		if (a != &(dead_anim[i]))//this test is a bit useless
		memcpy(a,&(dead_anim[i]),sizeof(DEAD_ENNEMI_ANIMATION_STRUCT));
		memset(&(dead_anim[i]),0,sizeof(DEAD_ENNEMI_ANIMATION_STRUCT));*/
	}
	
}


void draw_mario(PLAYER_STRUCT*p, short x_fg, short y_fg) {
	if (p->dead) {
		if (p->d.stuned_time) {
			p->d.stuned_time--;
			short sZ[20*3];
			if (p->d.stuned_orientation==1) {
				SpriteX8_MIRROR_H_R(20*3,(char*)stuned_mario,2,(char*)sZ);
			}
			else
			{
				memcpy(sZ,stuned_mario,20*3*2);
			}
			GrayClipISprite16_MASK_R(p->d.x-x_fg-1,(p->d.s_y>>V_S)-y_fg,20,sZ,pl,pd);
		}
		else
		{
			if (p->d.s_y>>V_S < 300) {
				GrayClipISprite16_MASK_R(p->d.x-x_fg,(p->d.s_y>>V_S)-y_fg,22,dead_mario,pl,pd);
				p->d.s_y+=p->d.s_vy;
				p->d.s_vy+=10;
			}
			else
			{
				if (!p->lives) {
					GraySpriteX8_MASK(TI89?44:84,TI89?42:56,16,game_over_sprite_1,game_over_sprite_2,game_over_mask,game_over_mask,9,pl,pd);
					GraySpriteX8_MASK(TI89?64:104,TI89?60:80,32,mario_gg1,mario_gg2,mario_gg_mask,mario_gg_mask,4,pd,pl);					
					//GrayTile32x32_MASK_R((TI89?8:13),TI89?60:80,mario_gg1,mario_gg2,mario_gg_mask,mario_gg_mask,pd,pl);
				}
				else
				{
					p->lives--;
					//init
					p->re.time_down = 30;
					p->re.block_time  = 6;
					p->s_x = 48<<H_S;
					p->s_y = 50<<V_S;
					//p->re.a=0;			
					p->dead = FALSE;
				}
			}
		}
	}
	else
	{
		GrayClipISprite16_MASK_R(p->x-x_fg,p->y-y_fg,P_HEIGHT,mario[p->step+(p->dir<<2)],pl,pd);
	}
}


void draw_coin(COIN_STRUCT* c, short x_fg, short y_fg) {
	c->x = c->X.s_x>>H_S;
	c->y = c->s_y>>V_S;
	GrayClipISprite8_MASK_R2(c->x-x_fg,c->y-y_fg,C_HEIGHT,coin_sprites+((c->frame<<4)*3),pl,pd);
}


void draw_anim(ANIMATION_STRUCT * a, short x_fg, short y_fg) {
	a->time--;
	if (a->time==0) {
		/**/short i=1;
		while (score_anim[i].time) {i++;};	
		score_anim[i].x = a->x;
		score_anim[i].y = a->y;
		//score_anim[i].time = 20;//BOOOOOO GNNIIIIII
		//a->time=20;//BOOOOOO GNNIIIIII

		score_anim[i].score=a->n;/**/
	}
	a->frame+=((a->time&0b11)==0b10)&(a->frame<4);
	GrayClipSprite16_AND_R(a->x-x_fg,a->y-y_fg+a->time,16,&bonus_star[a->frame<<4],&bonus_star[a->frame<<4],pl,pd);
}


void draw_score_anim(SCORE_ANIMATION_STRUCT * s, short x_fg, short y_fg) {
	s->time--;
	s->y-=((s->time&0b11)==0b10);
	GrayClipSprite16_MASK_R(s->x-x_fg,s->y-y_fg,8,&scores_sprites[s->score<<3],&scores_sprites[s->score<<3],&scores_sprites_mask[s->score<<3],&scores_sprites_mask[s->score<<3],pl,pd);
}


void draw_stalag(STALAG_STRUCT* s, short x_fg, short y_fg) {
	GrayClipISprite8_MASK_R2(s->x-x_fg,s->y-y_fg,16,&(stalag_sprites[s->frame]),pd,pl);
	if (s->shine)
	GrayClipSprite16_AND_R(s->x-x_fg-2,s->y-y_fg+15,5,&shine[s->shine+3],&shine[s->shine+3],pl,pd);
}


const char vx[] = {-1,-1,1,1};
const char vy[] = {1,-1,-1,1};


void draw_exploding_stalag(EXPLODING_STALAG_STRUCT *ex_s,short x,short y) {
	short i;
	short d=(14-ex_s->time);
	ex_s->time--;
	for (i=4;i--;)
	GrayClipSprite8_AND_R( ex_s->x+vx[i]*d-x, ex_s->y+vy[i]*d-y,8,&debris_glace[i<<3],&debris_glace[i<<3],pl,pd);	
}


static inline void freeze(short x, short y, short n) {
	short i;
	for (i=n;i--;) {
		if (map[y][x-i] == 1 && x-i >= 0)
		map[y][x-i]=73;
		if (map[y][x+i] == 1 && x+i < 32)
		map[y][x+i]=73;
	}
}


void draw_frozen_ground(FREEZE_GROUND_STRUCT* g) {
	g->time++;
	freeze(g->x,g->y,g->time);
	if (g->time == 10)
	g->on = FALSE;
}

void draw_exploding_icemen(EXPLODING_ICEMEN_STRUCT *explo,short x_fg, short y_fg) {
	explo->inter_frame++;
	if (explo->inter_frame==5) {
		explo->frame++;
		if (explo->frame == 3) {
			//score_anim[i].x = explo->x;
			//score_anim[i].y = explo->y;
			//if (explo->show_score)
			//score_anim[i].time = 20;
			//score_anim[i].score = 0;
			//short n=MAX_EXPLODING_ICEMEN-1;
			//number_of_icemen_explosion
			explo->on = FALSE;
			return;
		}
		explo->inter_frame = 0;
	}
	short sprite[6*16];
	short*sprite_p;
	
	
	if (explo->dir) {
		SpriteX8_MIRROR_H_R(16*3,(char*)(&exploding_iceman[explo->frame*48]),2,(char*)sprite);		
		sprite_p=sprite;
	}
	else
	{
		sprite_p=&exploding_iceman[explo->frame*48];
	}
	
	
	GrayClipISprite16_MASK_R(explo->x-x_fg,explo->y-y_fg,16,sprite_p,pl,pd);
}

void draw_phase_number(short x, short y, short level_num, char* p1, char* p2) {			
	char pipi[15];
	const char lulu[] = {'0'-5,'1'-5,'2'-5,'3'-5,'4'-5,' ','%','d',*""};
	sprintf(pipi,lulu,level_num);
	short i=0;
	while (pipi[i]) {
		if (pipi[i]!=' ')
		GraySprite8_TRANW_R(x+(i<<3),y,16,&phase_sprites_1[(pipi[i]-'0'+5)<<4],&phase_sprites_2[(pipi[i]-'0'+5)<<4],p2,p1);
		i++;
	}
}


void draw_life_left(short x, short y, char n, char* p1, char* p2) {
	

	
	char s[4];
	sprintf(s,"%i",n);
	

	
	
	



	GrayClipSprite8_MASK_R(x+24,y,8,&numbers_sprites[(s[0]-'0')<<3],&numbers_sprites[(s[0]-'0')<<3],&numbers_mask[(s[0]-'0')<<3],&numbers_mask[(s[0]-'0')<<3],p1,p2);
	GrayClipSprite32_MASK_R(x,y,8,life_num_1,life_num_2,life_num_mask,life_num_mask,p1,p2);
	/*GrayOff();
	ClrScr();
	printf(" %lp %lp    %lp %lp   %li",p1,p2,pl,pd,(char*)p2-(char*)p1);	
	while (1) ;*/
}


void draw_respawn(PLAYER_STRUCT * p, short x_fg, short y_fg) {


	short y=y;
	p->re.a++;
	if (p->re.time_down) {
		p->re.time_down-=(p->re.a&0b1)==0b1;
		p->s_x = 48<<H_S;
		p->s_y = (69-p->re.time_down)<<V_S;
		p->s_vy=-10;/**/
		GrayClipISprite16_MASK_R(48-x_fg,69-p->re.time_down-y_fg,P_HEIGHT,mario[p->dir<<2],pl,pd);
		y=74-p->re.time_down+23-y_fg;
		GrayClipSprite16_MASK_R(48-x_fg,68-p->re.time_down+20-y_fg,6,plateforme_1,plateforme_2,plateforme_mask,plateforme_mask,pl,pd);
		if (!p->re.time_down) {
			map_collision[11][6] = 1;
			map_collision[11][7] = 1;				
		}/**/
	}
	else
	{
		GrayClipSprite16_MASK_R(48-x_fg,68+20-y_fg,p->re.block_time,plateforme_1,plateforme_2,plateforme_mask,plateforme_mask,pl,pd);
		y=74+23-y_fg;
		draw_mario(p,x_fg,y_fg);
		p->re.block_time-=(p->re.a&0b111)==0b100;
		if (!p->re.block_time) {
			map_collision[11][6] = 0;
			map_collision[11][7] = 0;				
		}/**/
	}
	draw_life_left(40-x_fg,y,p->lives,pl,pd);
	//draw_life_left(0,y,p->lives,pl,pd);
}


void draw_masked_pipes(short x, short y) {
	if (y<100+24) {
		GrayClipISprite16_MASK_R(40-x,104-y,8*3,pipe_left,pl,pd);
		GrayClipISprite16_MASK_R(200-x,104-y,8*3,pipe_right,pl,pd);
	}
	else
	{
		GrayClipISprite16_MASK_R(24-x,264-y,8*3,pipe_left,pl,pd);
		GrayClipISprite16_MASK_R(216-x,264-y,8*3,pipe_right,pl,pd);
	}
}


void draw_fireball(FIREBALL_STRUCT * f, short x, short y) {
	GrayClipSprite16_AND_R(f->x-x,f->y-y,16,&fireball_large[f->sprite_num&0b11110000],&fireball_large[f->sprite_num&0b11110000],pd,pl);
}

void draw_mini_fireball(MINI_FIREBALL_STRUCT * f, short x, short y) {
	f->time++;
	if ((f->time&0b11) == 0b10) {
		f->sprite++;
		if (f->sprite == 4)
		f->sprite = 0;
		if (f->time>=40) {
			*(f->turn_on) = TRUE;
			f->on = FALSE;
		}
	}
	GrayClipSprite16_AND_R(f->x-x,f->y-y,16,&fireball_small[f->sprite<<4],&fireball_small[f->sprite<<4],pd,pl);
}


void draw_coin_io(COORD_STRUCT* c,short x, short y) {
	GrayClipISprite8_MASK_R2((c->x>>2)-x,(c->y>>2)-y,C_HEIGHT,coin_sprites+((3<<4)*3),pl,pd);
}


void draw_ennemi_out(ENNEMI_OUT_PIPE * e,short x, short y) {
	e->s_x+=e->s_vx;
	e->time--;
	if (!e->time) {
		*(e->visible) = TRUE;
		 e->e->x = e->e->X.s_x>>H_S;
		 e->e->y = e->e->s_y>>V_S;
	}
	GrayClipISprite16_MASK_R((e->s_x>>H_S)-x,(e->s_y>>V_S)-y,16,e->sprite,pl,pd);
}

void draw_ennemi_in(ENNEMI_IN_PIPE * e,short x, short y) {

	if (e->s_y > ((33*8+5)<<V_S)) {
		e->s_y-= (1<<(V_S-1));
	}
	else
	{
		e->s_x+=e->s_vx;
		e->time--;
	}

	GrayClipISprite16_MASK_R((e->s_x>>H_S)-x,(e->s_y>>V_S)-y,16,e->sprite,pl,pd);
}


static inline void clipPix(short x, short y, char *p1, char *p2) {
	if (x>=0 && x<240) {
		EXT_SETPIX(p1,x,y);
		EXT_SETPIX(p2,x,y);	
	}
}

void transition() {
	short i,j;
	short x,xy,x2,dir;
	x=-4;
	x2=LCD_WIDTH+24;
	for (i=LCD_WIDTH/2+14;i--;) {
		x++;
		xy=x;
		x2-=2;
		dir=-15;
		for (j=128;j--;) {
			xy+=(dir>0?1:-1);
			dir++;
			if (dir==15)
			dir=-15;
			clipPix(xy,j,GrayGetPlane(0),GrayGetPlane(1));
			clipPix(x2+xy,j,GrayGetPlane(0),GrayGetPlane(1));
		}	
	}
}