/* Copyright (C) 2005  Jean-Franois Geyelin */

#include "all.h"

//collsiion.c
short hit_left(PLAYER_STRUCT *);
short hit_right(PLAYER_STRUCT *);
short hit_top(PLAYER_STRUCT *);
short hit_bottom(PLAYER_STRUCT *);
short hit_left(PLAYER_STRUCT *);
short hit_bottom2(ENNEMI_STRUCT *);
short hit_bottom3(ENNEMI_STRUCT *);
short hit_bottom_coin2(COIN_STRUCT *);
short hit_bottom_coin3(COIN_STRUCT *);
short check_for_pow(PLAYER_STRUCT*,short*);
void init_collision();
void insert_ennemi_in_array(ENNEMI_STRUCT *);
void delete_ennemi_in_array(ENNEMI_STRUCT *);
void insert_coin_in_array(COIN_STRUCT *);
void delete_coin_in_array(COIN_STRUCT *);
void check_all_collision();
short hit_bottom_coin(COIN_STRUCT *);
void launch_new_coin(short);
short hit_side(ENNEMI_STRUCT *, short);
//score.c
void increase_score(PLAYER_STRUCT * , short);








short green_fireball_spawning_y[4] = {17*8,23*8,29*8,35*8};
short green_fireball_spawning_x[4] = {256-16-5,5};


void create_new_coin_going_out(short i,COIN_OUT_PIPE* cop) {
	short k=0;
	while (cop[k].time) {k++;};
	cop[k].s_x = (i?(25*8+4)<<2:(6*8-4)<<2);
	cop[k].s_y = (106)<<2;
	cop[k].s_vx = (i?(-1):1);
	cop[k].time = 32;
}

void move_coin_out(COIN_OUT_PIPE *c) {
	c->time--;
	c->s_x+=c->s_vx;
	if (!c->time)
	launch_new_coin(c->s_vx>0?1:0);
}


void create_new_coin_going_in(COIN_STRUCT * c) {
	COIN_IN_PIPE *new_coin = cip;
	while (new_coin->time) {new_coin++;};
	new_coin->s_x = c->X.s_x>>(H_S-2);
	new_coin->s_y = c->s_y>>(V_S-2);
	new_coin->s_vx = (c->X.s_vx<0?1:-1);
	new_coin->time = 50;
}

void move_coin_in(COIN_IN_PIPE *c) {
	c->time--;
	c->s_x-=c->s_vx;
	if (c->time>30)
	c->s_y-=3;
}

void init_green_fireball(GREEN_FIREBALL_STRUCT * f ,MINI_FIREBALL_STRUCT * mf,short y) {
	short choix;
	if (17*8>y) {
		choix = 0;
	}
	else
	{
		if (23*8>y) {
			choix = 1;
		}
		else
		{
			if (29*8>y) {
				choix = 2;
			}
			else
			{
				choix = 3;
			}
		}
	}
	f->y = green_fireball_spawning_y[choix];
	short r = random(2);
	f->x = green_fireball_spawning_x[r];
	f->vx = (r<<2)-2;
	f->time=0;
	f->s_time=0;
	f->speed = 30;
	f->sprite_num = 0;
	//f->on = TRUE;
	mf->x = f->x;
	mf->y = f->y;
	mf->on = TRUE;
	mf->turn_on = &(f->on);
	mf->time = 0;
	mf->sprite = 0;
}


void load_waiting_line(ENNEMI_STRUCT* e) {
	short i=0;
	while (ennemi_to_be_initialized[i]!=NULL)
	i++;
	ennemi_to_be_initialized[i] = e;
	e->visible = FALSE;
}


static unsigned char speed_array[] =
{
	30,50,70,//Turtle
	35,60,85,//Crabe
	20,30,40,//Bee
	42//Slipice
};

//7*8

void empty_waiting_line(short w) {
	ENNEMI_STRUCT* e = ennemi_to_be_initialized[0];
	if (e == NULL)
	return;
	e->visible = FALSE;//TRUE;//
	e->frame = 0;
	e->s_y = 106<<V_S;
  e->s_vy = 1;
  e->is_falling = TRUE;

  e->X.s_vx = speed_array[(e->move_function_id*3)+e->speed];
  e->X.s_vx = (w?e->X.s_vx:-e->X.s_vx);  
	e->a=0;
  e->b = 0;
	e->X.s_x = (w?(7*8)<<H_S:(23*8)<<H_S);
	e->X.must_be_reversed = FALSE;
	e->X.reversed_vx = 0;
	e->X.musnt_move = FALSE;
	e->reversed = 0;//FALSE;
	e->X.middle = 0;
	
	short i=MAX_NUMBER_OF_ENNEMIE_TO_BE_INIT-1;
	/*while (ennemi_to_be_initialized[i]==NULL) {i--;};
	ennemi_to_be_initialized[i] = NULL;
	memmove(ennemi_to_be_initialized,&ennemi_to_be_initialized[1],sizeof(ENNEMI_STRUCT*)*(MAX_NUMBER_OF_ENNEMIE_TO_BE_INIT-1));
*/


	while (ennemi_to_be_initialized[i]==NULL) {i--;};
	ennemi_to_be_initialized[0] = ennemi_to_be_initialized[i];
	ennemi_to_be_initialized[i] = NULL;
	
	i=0;
	while (eop[i].time) {
		i++;
	}
	ENNEMI_OUT_PIPE *ee=&(eop[i]);
	ee->s_vx = (w?1<<(H_S-1):-1<<(H_S-1));
	ee->s_x = (w?(5*8)<<H_S:(25*8)<<H_S);
	ee->s_y = e->s_y;
	ee->time = 32;
	ee->sprite = e->sprite+((e->X.s_vx<0)<<7)+((e->X.s_vx<0)<<4);
	ee->visible = &(e->visible);
	ee->e = e;
}


void create_new_eip(ENNEMI_STRUCT * e) {
	
	short i=0;
	while (eip[i].time) {
		i++;
	}
	ENNEMI_IN_PIPE *ee=&(eip[i]);
	ee->s_vx = (e->X.s_vx>0?1<<(H_S-1):-1<<(H_S-1));
	ee->s_x = (e->X.s_vx>0?(25*8)<<H_S:(5*8)<<H_S);
	ee->s_y = e->s_y;
	ee->time = 32;
	ee->sprite = e->sprite+((e->X.s_vx<0)<<7)+((e->X.s_vx<0)<<4);
	
}



void launch_new_coin(short w) {
	short i=0;
	while (coins[i].visible) {i++;};
	COIN_STRUCT* c = &(coins[i]);	
	c->visible = TRUE;
	c->frame = 0;
	c->s_y = 106<<6;
  c->s_vy = 1;
  c->is_falling = TRUE;
  c->X.s_vx = ((w<<1)-1)<<(H_S-1);
	c->X.s_x = (w?(6*8+4):(25*8-4))<<H_S;
	c->X.must_be_reversed= FALSE;
	c->X.id = ID_COIN;
	c->a=50;
}



void move_turtle(ENNEMI_STRUCT * e) {

	if (e->X.must_be_reversed) {
		increase_score(e->X.reversed_p,10);
		e->reversed=!e->reversed;
		if (e->reversed) {
			e->reversed_time = 400;
			delete_ennemi_in_array(e);
			e->is_falling = TRUE;
			e->s_y-=1<<V_S;
			e->s_vy=-200;
		}
		else
		{
			delete_ennemi_in_array(e);
			e->is_falling = TRUE;
			e->X.musnt_move = TRUE;
			e->s_y-=1<<V_S;
			e->s_vy=-200;
		}
		e->frame = 0;
		e->a=0;
		e->c=1;
		e->X.must_be_reversed = FALSE;
	}
	
	//Checks if the ennemi is starting to fall
	if (e->is_falling == FALSE && !hit_bottom3(e)) {		
		delete_ennemi_in_array(e);	
		e->is_falling = TRUE;		
	}
	
	//Move horizontaly.
	if (e->reversed) {	
		if (e->is_falling)
		e->X.s_x += e->X.reversed_vx;
	}
	else
	{
		if (!e->X.musnt_move)
		e->X.s_x += e->X.s_vx;
	}
	
	

	if (e->X.s_x > (256<<H_S))
	e->X.s_x=(-16<<H_S);
	if (e->X.s_x < (-16<<H_S))
	e->X.s_x=(256<<H_S);	
	//Move vertically
	e->s_vy+=16;
	e->s_y+=e->s_vy;
	
	if (hit_bottom2(e)) {
		if (e->is_falling) {
			e->is_falling = FALSE;
			e->y_when_on_ground=e->s_y>>6;
			insert_ennemi_in_array(e);
			if (e->X.musnt_move)
			e->X.musnt_move = FALSE;
		}
		e->s_vy = 0;
		while (hit_bottom2(e)) {
			e->s_y-=1<<6;
		}
	}
	
	e->a++;
	if (e->reversed) {
		//e->X.s_x -= e->X.s_vx;
		e->reversed_time--;
		if (!e->reversed_time) {
			e->reversed=FALSE;			
			e->speed++;
			if (e->speed==3)
			e->speed = 2;
		  e->X.s_vx = (e->X.s_vx>0?speed_array[(e->move_function_id*3)+e->speed]:-speed_array[(e->move_function_id*3)+e->speed]);
			
		}
		if (e->a>=((e->reversed_time)>>4)) {
			e->a=0;
			e->frame++;
			if (e->frame == 2)
			e->frame = 0;
		}
		if ((e->reversed_time)<100) {
			e->b++;
			if (e->b>=5) {
				e->c=-e->c;
				e->b=0;
			}
		}			
	}
	else
	{
		if (e->a>=5) {
			e->a=0;
			e->frame++;
			if (e->frame >= 3)
			e->frame = 0;
		}
	}
}



void move_coin(COIN_STRUCT * c) {
	//If the coin start falling
	if (c->is_falling == FALSE && !hit_bottom_coin3(c)) {		
		delete_coin_in_array(c);
		c->is_falling = TRUE;
	}
	//Horizontal mouvement
	c->X.s_x += c->X.s_vx;
	//Sprite animation
	c->a++;
	if (c->a>=15) {
		c->a=0;
		c->frame++;
		if (c->frame >= 5)
		c->frame = 0;
	}
	//If the coin goes at the end of a screen
	if (c->X.s_x > (256<<H_S))
	c->X.s_x=(-16<<H_S);
	if (c->X.s_x < (-16<<H_S))
	c->X.s_x=(256<<H_S);
	//Apply gravity
	c->s_vy+=16;
	c->s_y+=c->s_vy;
	if (hit_bottom_coin2(c)) {
		while (hit_bottom_coin2(c)) {
			c->s_y-=1<<6;
		}
		if (c->s_vy>20) {//if the coin was falling
			c->is_falling = FALSE;
			c->y_when_on_ground=c->s_y>>6;
			insert_coin_in_array(c);	
		}
		c->s_vy = 0;
	}
	if (c->X.must_be_reversed) {
		c->visible = FALSE;
		c->X.must_be_reversed = FALSE;
		increase_score(c->X.reversed_p,800);
		delete_coin_in_array(c);
		short i=0;
		while (anim[i].time) {i++;};
		anim[i].x=c->x-2;
		anim[i].y=c->y-26;
		anim[i].frame = 0;
		anim[i].time = 27;
		anim[i].n = 1;
	}
	if ((c->X.s_x<(44<<H_S) || c->X.s_x> (204<<H_S)) && c->s_y > (270<<V_S)) {
		c->visible= FALSE;
		create_new_coin_going_in(c);
		delete_coin_in_array(c);
	}
}






void move_crabe(ENNEMI_STRUCT * e) {
	if (e->X.must_be_reversed) {
		increase_score(e->X.reversed_p,10);
		
		if (e->reversed) {
			e->reversed = FALSE;
			e->was_hit_once = FALSE;
			delete_ennemi_in_array(e);
			e->is_falling = TRUE;
			e->s_y-=1<<V_S;
			e->s_vy=-200;	
		}
		else
		{
			if (e->was_hit_once) {
				delete_ennemi_in_array(e);
				e->is_falling = TRUE;
				e->X.musnt_move = TRUE;
				e->s_y-=1<<V_S;
				e->s_vy=-200;
				e->a=0;
				e->c=1;
				e->reversed = TRUE;	
				e->reversed_time = 400;
			}
			else {
				e->was_hit_once = TRUE;
				delete_ennemi_in_array(e);
				e->is_falling = TRUE;
				//e->X.musnt_move = TRUE;
				e->s_y-=1<<V_S;
				e->s_vy=-200;	
			}
		}
		

		e->frame = 0;
		e->a=0;
		e->c=1;
		e->X.must_be_reversed = FALSE;
	}
	//Checks if the ennemi is startinf to fall
	if (e->is_falling == FALSE && !hit_bottom3(e)) {		
		delete_ennemi_in_array(e);	
		e->is_falling = TRUE;		
	}
	
	//Move horizontaly.
	if (e->reversed) {	
		if (e->is_falling)
		e->X.s_x += e->X.reversed_vx;
	}
	else
	{
		if (!e->X.musnt_move)
		e->X.s_x += e->X.s_vx;
	}


	if (e->X.s_x > (256<<H_S))
	e->X.s_x=(-16<<H_S);
	if (e->X.s_x < (-16<<H_S))
	e->X.s_x=(256<<H_S);

	//Move vertically
	e->s_vy+=16;
	e->s_y+=e->s_vy;


	if (hit_bottom2(e)) {
		if (e->is_falling) {
			e->is_falling = FALSE;
			e->y_when_on_ground=e->s_y>>6;
			insert_ennemi_in_array(e);
			if (e->X.musnt_move)
			e->X.musnt_move = FALSE;
		}
		e->s_vy = 0;
		while (hit_bottom2(e)) {
			e->s_y-=1<<6;
		}
	}
	
	e->a++;
	if (e->reversed) {
		//e->X.s_x -= e->X.s_vx;
		e->reversed_time--;
		if (!e->reversed_time) {
			e->reversed=FALSE;
			e->was_hit_once = FALSE;
		}
		if (e->a>=((e->reversed_time)>>4)) {
			e->a=0;
			e->frame++;
			if (e->frame == 2)
			e->frame = 0;
		}
		if ((e->reversed_time)<100) {
			e->b++;
			if (e->b>=5) {
				e->c=!e->c;
				e->b=0;
			}
		}			
	}
	else
	{
		if (e->a>=5) {
			e->a=0;
			e->frame++;
			if (e->frame >= 3)
			e->frame = 0;
		}
	}
}



static unsigned char spots_for_the_icemen[] = {	
200,200,200,200,200,200,200,200,200,200,
200,200,200,200,200,200,200,200,200,200,
200,200,200,0,200,200,200,200,200,80,
200,200,200,200,200,200,200,200
};




void move_iceman(ENNEMI_STRUCT * e) {
	short i=0;
	if (e->X.must_be_reversed) {
		//e->X.s_x += 40<<H_S;
		e->visible = FALSE;
		e->reserved = FALSE;
		e->X.must_be_reversed = FALSE;
		increase_score(e->X.reversed_p,500);
		

		while (exploding_icemen[i].on) {
			i++;
		}
		
		
		exploding_icemen[i].x = e->X.s_x>>H_S;
		exploding_icemen[i].y = e->s_y>>V_S;
		exploding_icemen[i].frame = 0;
		exploding_icemen[i].inter_frame = 0;	
		exploding_icemen[i].dir = e->X.s_vx<0;
		exploding_icemen[i].show_score	= TRUE;//TRUE;
		exploding_icemen[i].on = TRUE;
		//number_of_icemen_explosion++;
		delete_ennemi_in_array(e);
		//e->X.s_x = 400<<H_S;//Corrects the gost ennemi bug
		return;
	}

	//Checks if the ennemi is startinf to fall
	if (e->is_falling == FALSE && !hit_bottom3(e)) {		
		delete_ennemi_in_array(e);	
		e->is_falling = TRUE;	
	}
	
	//Move horizontaly.
	e->X.s_x += e->X.s_vx;
	if (e->X.s_x > (256<<H_S))
	e->X.s_x=(-16<<H_S);
	if (e->X.s_x < (-16<<H_S))
	e->X.s_x=(256<<H_S);
	
	//Move vertically
	e->s_vy+=12;
	e->s_y+=e->s_vy;
	
	if (hit_bottom2(e)) {
		if (e->is_falling) {
			e->is_falling = FALSE;
			e->y_when_on_ground=e->s_y>>6;
			insert_ennemi_in_array(e);
			if (e->X.musnt_move)
			e->X.musnt_move = FALSE;
		}
		e->s_vy = 0;
		while (hit_bottom2(e)) {
			e->s_y-=1<<6;
		}
	}
	
	e->a++;
	if (e->a>=5) {
		e->a=0;
		e->frame++;
		if (e->frame >= 3)
		e->frame = 0;
	}
	
	//Checks if the iceman must stop and try to freeze the ground:
	
	if (    abs(     abs(e->x+8-128)      -       spots_for_the_icemen[e->s_y>>(V_S+3)]    )   <1   && map[(e->s_y>>(V_S+3))+2][(e->X.s_x>>(H_S+3))+1]!=73) {
		e->X.s_vx = 0;

	}
		
	if (e->X.s_vx==0) {
			e->b++;
			if (e->b==40) {
				//e->X.s_x = 400<<H_S;
				e->visible = FALSE;
				e->reserved = FALSE;
				i=0;
				while (exploding_icemen[i].on) {i++;};
				
				exploding_icemen[i].x = e->X.s_x>>H_S;
				exploding_icemen[i].y = e->s_y>>V_S;
				exploding_icemen[i].frame = 0;
				exploding_icemen[i].inter_frame = 0;	
				exploding_icemen[i].dir = e->X.s_vx<0;	
				exploding_icemen[i].show_score	= FALSE;
				exploding_icemen[i].on = TRUE;				
				//number_of_icemen_explosion++;		
				short i=0;
				while (freeze_g[i].on) {i++;};
				freeze_g[i].on=TRUE;
				freeze_g[i].y=(e->s_y>>(V_S+3))+2;
				freeze_g[i].x = (e->X.s_x>>(H_S+3))+1;
				freeze_g[i].time=0;
				delete_ennemi_in_array(e);
				//e->X.s_x = 400<<H_S;//Corrects the gost ennemi bug
			}
	}
}



void move_bee(ENNEMI_STRUCT * e) {
	

	
	if (e->X.must_be_reversed) {
		increase_score(e->X.reversed_p,10);
		e->reversed=!e->reversed;
		if (e->reversed) {
			e->reversed_time = 400;
			delete_ennemi_in_array(e);
			e->is_falling = TRUE;
			e->s_y-=1<<V_S;
			e->s_vy=-200;
		}
		else
		{
			delete_ennemi_in_array(e);
			e->is_falling = TRUE;
			e->X.musnt_move = TRUE;
			e->s_y-=1<<V_S;
			e->s_vy=-300;
		}
		e->frame = 0;
		e->a=0;
		e->c=1;
		e->X.must_be_reversed = FALSE;
	}
	
	//Checks if the ennemi is starting to fall
	if (e->is_falling == FALSE && !hit_bottom3(e)) {		
		delete_ennemi_in_array(e);	
		e->is_falling = TRUE;		
	}
	
	//Move horizontaly.
	if (e->reversed) {	
		if (e->is_falling) {
			e->X.s_x += e->X.reversed_vx;
			if (hit_side(e,e->X.reversed_vx)) {
				e->X.reversed_vx = -e->X.reversed_vx;
				while (hit_side(e,e->X.reversed_vx))
				e->X.s_x += e->X.reversed_vx;
			}
		}
		
	}
	else
	{
		e->a++;
		if (e->X.musnt_move == TRUE) {
			
			if (e->a >= 40 && e->frame == 0) {
				e->a = 0;
				e->frame = 1;
				delete_ennemi_in_array(e);
				e->is_falling = TRUE;
				e->s_y-=1<<V_S;
				e->s_vy=-300;
				
			}
		}
		if (e->frame != 0) {
			e->X.s_x += e->X.s_vx;
			if (hit_side(e,e->X.s_vx)) {
				e->X.s_vx = -e->X.s_vx;
				while (hit_side(e,e->X.s_vx))
				e->X.s_x += e->X.s_vx;
			}
			if (e->a >= 8) {
				if (e->frame == 1)
				e->frame = 2;
				else
				e->frame = 1;
				e->a = 0;
			}
		}
	}
	
	

	if (e->X.s_x > (256<<H_S))
	e->X.s_x=(-16<<H_S);
	if (e->X.s_x < (-16<<H_S))
	e->X.s_x=(256<<H_S);
	
	//Move vertically
	e->s_vy+=16;
	e->s_y+=e->s_vy>>2;	
	
	//GrayDrawChar2B(random(40),0,'0'+e->a,A_REPLACE,GrayGetPlane(1),GrayGetPlane(0));
	//GrayDrawChar2B(0,8,'0'+e->frame,A_REPLACE,GrayGetPlane(1),GrayGetPlane(0));

	if (hit_bottom2(e)) {
		if (e->is_falling) {
			e->is_falling = FALSE;
			e->y_when_on_ground=e->s_y>>6;
			insert_ennemi_in_array(e);
			
			e->frame = 0;
			e->X.musnt_move = TRUE;
			e->a = 0;

		}
		e->s_vy = 0;
		while (hit_bottom2(e)) {
			e->s_y-=1<<6;
		}
	}
	
	//e->a++;
	if (e->reversed) {
		//e->X.s_x -= e->X.s_vx;
		e->reversed_time--;
		if (!e->reversed_time) {
			e->reversed=FALSE;			
			e->speed++;
			if (e->speed==3)
			e->speed = 2;
		  e->X.s_vx = (e->X.s_vx>0?speed_array[(e->move_function_id*3)+e->speed]:-speed_array[(e->move_function_id*3)+e->speed]);
		}
		if (e->a>=((e->reversed_time)>>4)) {
			e->a=0;
			e->frame++;
			if (e->frame == 2)
			e->frame = 0;
		}
		if ((e->reversed_time)<100) {
			e->b++;
			if (e->b>=5) {
				e->c=-e->c;
				e->b=0;
			}
		}			
	}

	
}









//0 => +1
//1 => -1

static unsigned short green_vy_fireball[] = {0b1111100000111111,0b1111100000000000};

void move_green_fireball(GREEN_FIREBALL_STRUCT * f, MINI_FIREBALL_STRUCT * mf) {
	f->s_time+=f->speed;
	if (f->s_time>=100) {
		f->s_time-=100;
		//Changes the displayed sprite
		f->sprite_num+=8;
		if (f->sprite_num>(16*3))
		f->sprite_num=0;
		//Calculates the movement the fireball is doing (up or down)
		//if 
		//f->y-=2;
		//else
		//f->y+=2;
		
		f->y+=(((green_vy_fireball[f->time>15]&(0b1000000000000000>>(f->time&0b1111))))?-2:2);
		f->time++;
		if (f->time==32)
		f->time=0;
		f->x+=f->vx;
		
		if (f->x< 0 || f->x>235) {
			f->on = FALSE;
			mf->x = f->x;
			mf->y = f->y;
			mf->on = TRUE;
			mf->turn_on = &(mf->on);//lololol hahahahah so funny!
			mf->time = 0;
			mf->sprite = 0;
		}
	}
}


